#include <stdlib.h>
#include <stdio.h>

/* Convert monochrome 8 bits per pixel raw image to
   monochrome 4 bits per pixel raw image
*/

int main( int argc, char *argv[] )
{
    if (argc != 3 )
    {
        fprintf(stderr, "Need 2 parameters. Input and output file\n");
        return 0;
    }
    
    FILE *i, *o;
    
    i = fopen(argv[1], "rb");
    o = fopen(argv[2], "wb");
    
    if (!i)
    {
        fprintf(stderr, "Input file %s not found.\n", argv[1] );
        return 0;
    }
    
    if (!o)
    {
        fprintf(stderr, "Output file %s could not be created.\n", argv[2] );
        return 0;
    }
    
    int c, d, w;
    
    while(1)
    {
        c = fgetc(i);
    
        if (feof(i))
            return 0;
    
        d = fgetc(i);
    
        if (feof(i))
            return 0;
        
        c >>= 4;
        d >>= 4;
        
        w = (c << 4) + d;
    
        fputc(w,o);
    }
    
    return 0;
}